apiVersion: v1
kind: Namespace
metadata:
  name: compile
---
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRoleBinding
metadata:
  name: default-view
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: admin
subjects:
  - kind: ServiceAccount
    name: default
    namespace: aasp
---
apiVersion: v1
kind: ConfigMap
metadata:
  name: code-config
  namespace: aasp
data:
  STORAGE_ENDPOINT: s3store-svc.aasp
  STORAGE_SSL: "false"
  STORAGE_BUCKET: aaspcompiler
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: worker-code
  namespace: aasp
spec:
  selector:
    matchLabels:
      app: worker-code
  template:
    metadata:
      labels:
        app: worker-code
    spec:
      containers:
      - name: worker-code
        image: registry.gitlab.com/kennethsyq_university_fyp/fyp/worker-code:latest
        resources:
          limits:
            memory: "250Mi"
            cpu: "750m"
          requests:
            memory: "10Mi"
            cpu: "10m"
        env:
          - name: CONCURRENCY
            value: "10"
          - name: QUEUE
            valueFrom:
              configMapKeyRef:
                name: common-app-config
                key: QUEUE_CODE
          - name: QUEUE_SUBMISSION
            valueFrom:
              configMapKeyRef:
                name: common-app-config
                key: QUEUE_SUBMISSION
          - name: WORKER_MODE
            value: kubernetes
          - name: CPU_LIMIT
            value: "5"
          - name: MEM_LIMIT
            value: "1024"
          - name: SUB_CONCURRENCY
            value: "-1"
          - name: KUBE_CLUSTER
            value: "0"
          - name: KUBE_NAMESPACE
            value: compile
          # Common Env MySQL
          - name: MYSQL_USER
            valueFrom:
              configMapKeyRef:
                name: common-app-config
                key: MYSQL_USER
          - name: MYSQL_DATABASE
            valueFrom:
              configMapKeyRef:
                name: common-app-config
                key: MYSQL_DATABASE
          - name: MYSQL_PASSWORD
            valueFrom:
                secretKeyRef:
                  name: dbsecret
                  key: MYSQL_PASSWORD
          - name: MYSQL_HOST
            valueFrom:
              configMapKeyRef:
                name: routing-config
                key: DB_HOST
          # Common Env Redis
          - name: REDIS_HOST
            valueFrom:
              configMapKeyRef:
                name: routing-config
                key: REDIS_HOST
          - name: REDIS_PASSWORD
            valueFrom:
                secretKeyRef:
                  name: cachesecret
                  key: REDIS_PASSWORD
          # Storage
          - name: STORAGE_ENDPOINT
            valueFrom:
              configMapKeyRef:
                name: code-config
                key: STORAGE_ENDPOINT
          - name: STORAGE_SSL
            valueFrom:
              configMapKeyRef:
                name: code-config
                key: STORAGE_SSL
          - name: STORAGE_BUCKET
            valueFrom:
              configMapKeyRef:
                name: code-config
                key: STORAGE_BUCKET
          - name: STORAGE_SECRET_KEY
            valueFrom:
                secretKeyRef:
                  name: storagesecret
                  key: MINIO_SECRET_KEY
          - name: STORAGE_ACCESS_KEY
            valueFrom:
              configMapKeyRef:
                name: common-app-config
                key: MINIO_ACCESS_KEY
          - name: STORAGE_PORT
            valueFrom:
              configMapKeyRef:
                name: routing-config
                key: STORAGE_PORT
